-----------------------------------------------------------
-- production
-----------------------------------------------------------

function ProductionMinister_Tick(minister)
	if minister:GetCountry():GetCountryTag() == CCountryDataBase.GetTag('GER') then
		AutoSliders( minister:GetOwnerAI(), minister:GetCountry() )
	else 
		BalanceProductionSliders( minister:GetOwnerAI(), minister:GetCountry() )
		ManageProduction(minister)
	end
end


function BalanceProductionSliders(ai, ministerCountry)
	local PRIO_SETTINGS = {
		[0] = CDistributionSetting._PRODUCTION_CONSUMER_, 
		CDistributionSetting._PRODUCTION_SUPPLY_,
		CDistributionSetting._PRODUCTION_REINFORCEMENT_,	
		CDistributionSetting._PRODUCTION_PRODUCTION_,
		CDistributionSetting._PRODUCTION_UPGRADE_
	}

	local sum = 0
	local changes = CArrayFix(5)	

	for setting = 0, table.getn(PRIO_SETTINGS) do
		local slider = ministerCountry:GetProductionDistributionAt( setting )
		local percentage = slider:GetNeeded():Get() / ministerCountry:GetTotalIC()
		percentage = percentage * 100
		changes:SetAt( setting, CFixedPoint( math.max(percentage, 0.0 ) ) )
	end
	
	-- special considerations
	local dissent = ministerCountry:GetDissent():Get()
	if dissent > 0.01 then -- fight dissent 
		changes:SetAt( CDistributionSetting._PRODUCTION_CONSUMER_, changes:GetAt( CDistributionSetting._PRODUCTION_CONSUMER_ ) + 10 )
	elseif ministerCountry:GetDailyBalance(CGoodsPool._MONEY_):Get() < 0.0 
	and ministerCountry:GetPool():Get( CGoodsPool._MONEY_ ):Get() < 30 then
		changes:SetAt( CDistributionSetting._PRODUCTION_CONSUMER_, changes:GetAt( CDistributionSetting._PRODUCTION_CONSUMER_ ) + 10 )
	end

	local supplyStockpile = ministerCountry:GetPool():Get( CGoodsPool._SUPPLIES_ ):Get()
	local weeksSupplyUse = ministerCountry:GetDailyExpense( CGoodsPool._SUPPLIES_ ):Get() * 7
	if supplyStockpile < weeksSupplyUse then
		changes:SetAt( CDistributionSetting._PRODUCTION_SUPPLY_, changes:GetAt( CDistributionSetting._PRODUCTION_SUPPLY_ ) + 10 )
	elseif supplyStockpile > weeksSupplyUse * 4.0 then
		changes:SetAt( CDistributionSetting._PRODUCTION_SUPPLY_, changes:GetAt( CDistributionSetting._PRODUCTION_SUPPLY_ ) - 10 )
	end

		--Utils.LUA_DEBUGOUT("_PRODUCTION_CONSUMER_: " ..  changes:GetAt( CDistributionSetting._PRODUCTION_CONSUMER_):Get())
		--Utils.LUA_DEBUGOUT("_PRODUCTION_SUPPLY_: " ..  changes:GetAt( CDistributionSetting._PRODUCTION_SUPPLY_):Get())
		--Utils.LUA_DEBUGOUT("_PRODUCTION_REINFORCEMENT_: " ..  changes:GetAt( CDistributionSetting._PRODUCTION_REINFORCEMENT_):Get())
		--Utils.LUA_DEBUGOUT("_PRODUCTION_PRODUCTION_: " ..  changes:GetAt( CDistributionSetting._PRODUCTION_PRODUCTION_):Get())
		--Utils.LUA_DEBUGOUT("_PRODUCTION_UPGRADE_: " ..  changes:GetAt( CDistributionSetting._PRODUCTION_UPGRADE_):Get())

	-- reinforcement vs production,
	
	
	
	local factor_left = 100
	for i = 0, table.getn(PRIO_SETTINGS) do -- normalize
		local index = PRIO_SETTINGS[i]
		local factor = changes:GetAt( index ):Get()
		factor = math.min(factor, factor_left)
		factor_left = math.max(factor_left - factor, 0.0)

		changes:SetAt( index, CFixedPoint(factor) )
	end
	
	factor_left = math.max(factor_left, 0.0)
	changes:SetAt( CDistributionSetting._PRODUCTION_PRODUCTION_, changes:GetAt(CDistributionSetting._PRODUCTION_PRODUCTION_) + factor_left )

		--Utils.LUA_DEBUGOUT("---------")
		--Utils.LUA_DEBUGOUT("_PRODUCTION_CONSUMER_: " ..  changes:GetAt( CDistributionSetting._PRODUCTION_CONSUMER_):Get())
		--Utils.LUA_DEBUGOUT("_PRODUCTION_SUPPLY_: " ..  changes:GetAt( CDistributionSetting._PRODUCTION_SUPPLY_):Get())
		--Utils.LUA_DEBUGOUT("_PRODUCTION_REINFORCEMENT_: " ..  changes:GetAt( CDistributionSetting._PRODUCTION_REINFORCEMENT_):Get())
		--Utils.LUA_DEBUGOUT("_PRODUCTION_PRODUCTION_: " ..  changes:GetAt( CDistributionSetting._PRODUCTION_PRODUCTION_):Get())
		--Utils.LUA_DEBUGOUT("_PRODUCTION_UPGRADE_: " ..  changes:GetAt( CDistributionSetting._PRODUCTION_UPGRADE_):Get())
		--Utils.LUA_DEBUGOUT("-------------------------------------------------")

	local command = CChangeInvestmentCommand( ministerCountry:GetCountryTag(), changes )
	ai:Post( command )	
end

function AutoSliders(ai, ministerCountry)
	local PRIO_SETTINGS = {
		[0] = CDistributionSetting._PRODUCTION_CONSUMER_, 
		CDistributionSetting._PRODUCTION_SUPPLY_,
		CDistributionSetting._PRODUCTION_REINFORCEMENT_,	
		CDistributionSetting._PRODUCTION_PRODUCTION_,
		CDistributionSetting._PRODUCTION_UPGRADE_
	}

	local sum = 0
	local changes = CArrayFix(5)	

	for setting = 0, table.getn(PRIO_SETTINGS) do
		local slider = ministerCountry:GetProductionDistributionAt( setting )
		local percentage = slider:GetNeeded():Get() / ministerCountry:GetTotalIC()
		percentage = percentage * 100
		changes:SetAt( setting, CFixedPoint( math.max(percentage, 0.0 ) ) )
	end
	
	-- special considerations
	local dissent = ministerCountry:GetDissent():Get()
	if dissent > 0.01 then -- fight dissent 
		changes:SetAt( CDistributionSetting._PRODUCTION_CONSUMER_, changes:GetAt( CDistributionSetting._PRODUCTION_CONSUMER_ ) + 10 )
	elseif ministerCountry:GetDailyBalance(CGoodsPool._MONEY_):Get() < 0.0 
	and ministerCountry:GetPool():Get( CGoodsPool._MONEY_ ):Get() < 30 then
		changes:SetAt( CDistributionSetting._PRODUCTION_CONSUMER_, changes:GetAt( CDistributionSetting._PRODUCTION_CONSUMER_ ) + 10 )
	end

	local supplyStockpile = ministerCountry:GetPool():Get( CGoodsPool._SUPPLIES_ ):Get()
	local weeksSupplyUse = ministerCountry:GetDailyExpense( CGoodsPool._SUPPLIES_ ):Get() * 7
	if supplyStockpile < weeksSupplyUse then
		changes:SetAt( CDistributionSetting._PRODUCTION_SUPPLY_, changes:GetAt( CDistributionSetting._PRODUCTION_SUPPLY_ ) + 10 )
	end

		--Utils.LUA_DEBUGOUT("_PRODUCTION_CONSUMER_: " ..  changes:GetAt( CDistributionSetting._PRODUCTION_CONSUMER_):Get())
		--Utils.LUA_DEBUGOUT("_PRODUCTION_SUPPLY_: " ..  changes:GetAt( CDistributionSetting._PRODUCTION_SUPPLY_):Get())
		--Utils.LUA_DEBUGOUT("_PRODUCTION_REINFORCEMENT_: " ..  changes:GetAt( CDistributionSetting._PRODUCTION_REINFORCEMENT_):Get())
		--Utils.LUA_DEBUGOUT("_PRODUCTION_PRODUCTION_: " ..  changes:GetAt( CDistributionSetting._PRODUCTION_PRODUCTION_):Get())
		--Utils.LUA_DEBUGOUT("_PRODUCTION_UPGRADE_: " ..  changes:GetAt( CDistributionSetting._PRODUCTION_UPGRADE_):Get())

	-- reinforcement vs production,
	
	
	
	local factor_left = 100
	for i = 0, table.getn(PRIO_SETTINGS) do -- normalize
		local index = PRIO_SETTINGS[i]
		local factor = changes:GetAt( index ):Get()
		factor = math.min(factor, factor_left)
		factor_left = math.max(factor_left - factor, 0.0)

		changes:SetAt( index, CFixedPoint(factor) )
	end
	
	factor_left = math.max(factor_left, 0.0)
	if supplyStockpile < 99000 then	
		changes:SetAt( CDistributionSetting._PRODUCTION_SUPPLY_, changes:GetAt(CDistributionSetting._PRODUCTION_SUPPLY_) + factor_left )
	else
		changes:SetAt( CDistributionSetting._PRODUCTION_CONSUMER_, changes:GetAt(CDistributionSetting._PRODUCTION_CONSUMER_) + factor_left )
	end

		--Utils.LUA_DEBUGOUT("---------")
		--Utils.LUA_DEBUGOUT("_PRODUCTION_CONSUMER_: " ..  changes:GetAt( CDistributionSetting._PRODUCTION_CONSUMER_):Get())
		--Utils.LUA_DEBUGOUT("_PRODUCTION_SUPPLY_: " ..  changes:GetAt( CDistributionSetting._PRODUCTION_SUPPLY_):Get())
		--Utils.LUA_DEBUGOUT("_PRODUCTION_REINFORCEMENT_: " ..  changes:GetAt( CDistributionSetting._PRODUCTION_REINFORCEMENT_):Get())
		--Utils.LUA_DEBUGOUT("_PRODUCTION_PRODUCTION_: " ..  changes:GetAt( CDistributionSetting._PRODUCTION_PRODUCTION_):Get())
		--Utils.LUA_DEBUGOUT("_PRODUCTION_UPGRADE_: " ..  changes:GetAt( CDistributionSetting._PRODUCTION_UPGRADE_):Get())
		--Utils.LUA_DEBUGOUT("-------------------------------------------------")

	local command = CChangeInvestmentCommand( ministerCountry:GetCountryTag(), changes )
	ai:Post( command )	
end


-- for debugging
--local GOODS_TO_STRING = { [0] = "_SUPPLIES_","_FUEL_",	"_MONEY_",	"_CRUDE_OIL_",	"_METAL_",	"_ENERGY_",	"_RARE_MATERIALS_" }


function ManageProduction(minister)
	local ministerTag = minister:GetCountryTag()
	local ministerCountry = minister:GetCountry()
	local ai = minister:GetOwnerAI() 
	local strategy = ministerCountry:GetStrategy()
	local capitalProvId =  ministerCountry:GetActingCapitalLocation():GetProvinceID()

	--local ic = ministerCountry:GetAvailableIC() 
	local ic = ministerCountry:GetICPart( CDistributionSetting._PRODUCTION_PRODUCTION_ ):Get()
	ic = ic - ministerCountry:GetUsedIC():Get()
	--Utils.LUA_DEBUGOUT( "ic before " .. tostring(ic) )
	
	-- ai list of requests, in prio order
	local bBuildReserve = not ministerCountry:IsAtWar()
	local requestQueue = ai:GetReqProdQueue()
	--Utils.LUA_DEBUGOUT(tostring(ministerTag) .. " checkign queue and ic is " .. ic)
	while (not requestQueue:IsEmpty()) and ic >= 0.0 do
		local unit = requestQueue:GetTailData().pUnit
	
		local tmp = ministerCountry:GetBuildCostIC( unit, 1, bBuildReserve ):Get()
		
		--Utils.LUA_DEBUGOUT(tostring(ministerTag) .. " " .. tostring(unit:GetKey()) .. " cost " .. tmp .. ", we got ic " .. tostring(ic) )
		
		ic = ic - tmp
		
		--Utils.LUA_DEBUGOUT( tostring(ministerTag) .. " " .."leftover ic " .. tostring(ic) )
		
		--if ic >= 0.0 then
			requestQueue:RemoveTail()
	
			local orderlist = SubUnitList()
			SubUnitList.Append( orderlist, unit )

			local construct = CConstructUnitCommand( ministerTag, orderlist, capitalProvId, 1, bBuildReserve, CNullTag(), CID() )
			ai:Post( construct )
		--end
	end
	
	--Utils.LUA_DEBUGOUT( "------" )
	
	-- any requests by strategic ai
	for subunit in CSubUnitDataBase.GetSubUnitList() do 
		local count = strategy:GetWantedSubUnits(subunit)
		if count > 0.0 then
			local orderlist = SubUnitList()
			SubUnitList.Append( orderlist, subunit )
			local construct = CConstructUnitCommand( ministerTag, orderlist, capitalProvId, count, false, CNullTag(), CID() )
			ai:Post( construct ) 
		end
	end
	
	-- we need convoys at all?
	ic = ConstructConvoys(ai, minister, ministerTag, ministerCountry, ic )
		
	--Utils.LUA_DEBUGOUT("---------------" )
	
	
	
	-- Buildings
	if ic >= 0 then
		if not ( ministerCountry:IsAtWar() or ministerCountry:GetStrategy():IsPreparingWar() ) then 
			local factory = CBuildingDataBase.GetBuilding( "industry" )
			local factoryCost = ministerCountry:GetBuildCost( factory ):Get()
			
			for provinceId in ministerCountry:GetOwnedProvinces() do
				local province = CCurrentGameState.GetProvince( provinceId )
				
				--Utils.LUA_DEBUGOUT("b4")
				ic = ic - factoryCost
				if ic < 0.0 then		
					break
				end
				--Utils.LUA_DEBUGOUT("build with " .. tostring(ministerTag) )
								
				if ministerCountry:IsBuildingAllowed(factory, province)
				and (not province:IsFrontProvince(false) )
				--and (not province:HasAdjacentEnemyOrCB() ) 
				and province:GetInfrastructure():Get() > 0.3 then
					local constructCommand = CConstructBuildingCommand( ministerTag, factory, provinceId, 1 )
					if constructCommand:IsValid() then
						ai:Post( constructCommand )
						--Utils.LUA_DEBUGOUT("building factory in " .. provinceId .. 
						--				  " for " .. tostring(ministerTag) .. 
						--				  " costing: " .. factoryCost ..
						--				  " of IC left: " .. ic )
						break -- one enough for now
					end
				end
			end
		end
		
		-- look at building defences
		local costalFort = CBuildingDataBase.GetBuilding( "coastal_fort" )
		local costalFortCost = ministerCountry:GetBuildCost( costalFort ):Get()
		--if ministerCountry:GetStrategicWarfare():GetBombingImpact():Get() > 0.3 then 
		for navalBaseProvince in ministerCountry:GetNavalBases() do
			--Utils.LUA_DEBUGOUT("navalBaseProvince " )
			if not navalBaseProvince:HasBuilding( costalFort ) then
				--Utils.LUA_DEBUGOUT("WANT building coastal fort in " .. navalBaseProvince:GetProvinceID() .. 
				--					  " for " .. tostring(ministerTag) .. 
				--					  " costing: " .. costalFortCost ..
				--					  " of IC left: " .. ic )
				if ministerCountry:IsBuildingAllowed(costalFort, navalBaseProvince) then
					--Utils.LUA_DEBUGOUT("building is allowed")
					ic = ic - costalFortCost
					if ic < 0.0 then		
						break
					end
					--Utils.LUA_DEBUGOUT("building coastal fort in " .. navalBaseProvince:GetProvinceID() .. 
					--				  " for " .. tostring(ministerTag) .. 
					--				  " costing: " .. costalFortCost ..
					--				  " of IC left: " .. ic )
				  
					local constructCommand = CConstructBuildingCommand( ministerTag, costalFort, navalBaseProvince:GetProvinceID(), 1 )
					if constructCommand:IsValid() then
						ai:Post( constructCommand )

						break -- one enough for now
					end
				end
			end
		end
		
		local antiAir = CBuildingDataBase.GetBuilding( "anti_air" )
		local antiAirCost = ministerCountry:GetBuildCost( antiAir):Get()
		for airBaseProvince in ministerCountry:GetAirBases() do
			--Utils.LUA_DEBUGOUT("airBaseProvince " )
			if not airBaseProvince:HasBuilding( antiAir ) then
				--Utils.LUA_DEBUGOUT("WANT building AA in " .. airBaseProvince:GetProvinceID() .. 
				--					  " for " .. tostring(ministerTag) .. 
				--					  " costing: " .. antiAirCost ..
				--					  " of IC left: " .. ic )
				if ministerCountry:IsBuildingAllowed(antiAir, airBaseProvince) then
					--Utils.LUA_DEBUGOUT("building is allowed")
					ic = ic - antiAirCost
					if ic < 0.0 then		
						break
					end
					--Utils.LUA_DEBUGOUT("building AA in " .. airBaseProvince:GetProvinceID() .. 
					---				  " for " .. tostring(ministerTag) .. 
					--				  " costing: " .. antiAirCost ..
					--				  " of IC left: " .. ic )
				  
					local constructCommand = CConstructBuildingCommand( ministerTag, antiAir, airBaseProvince:GetProvinceID(), 1 )
					if constructCommand:IsValid() then
						ai:Post( constructCommand )

						break -- one enough for now
					end
				end
			end
		end
		
		
	end
	
	
	--Utils.LUA_DEBUGOUT( "ic at end > " .. tostring(ic) )
	local manpower = ministerCountry:GetManpower():Get()
	--Utils.LUA_DEBUGOUT( "mp at end > " .. tostring(manpower) )

	-- always fill out with more infantry if possible.
	if ic > 0 and manpower > 10 then
		--Utils.LUA_DEBUGOUT( "has ic and manpower" )

		local orderlist = SubUnitList()
		local infantry = CSubUnitDataBase.GetSubUnit("infantry_brigade")
		local militia = CSubUnitDataBase.GetSubUnit("militia_brigade")
		if ministerCountry:GetTechnologyStatus():IsUnitAvailable(infantry) then 
			SubUnitList.Append( orderlist, infantry )
			SubUnitList.Append( orderlist, infantry )
			SubUnitList.Append( orderlist, infantry )
		else
			SubUnitList.Append( orderlist, militia )
			SubUnitList.Append( orderlist, militia )
			SubUnitList.Append( orderlist, militia )
		end
		--Utils.LUA_DEBUGOUT( "builds a division." )
		local construct = CConstructUnitCommand( ministerTag, orderlist, capitalProvId, 1, bBuildReserve, CNullTag(), CID() )
		ai:Post( construct )
	end
end


function ConstructConvoys(ai, minister, ministerTag, ministerCountry, ic )

	local ministerPortCount = ministerCountry:GetNumOfPorts()
	if ministerPortCount > 0 then
		local freeTransports = ministerCountry:GetTransports() 
		if freeTransports < ministerPortCount*2 then
			local neededTransports = ministerCountry:GetTotalNeededTransports()
			neededTransports = neededTransports + (ministerPortCount - freeTransports) -- want some spares
			neededTransports = neededTransports - minister:CountTransportsUnderConstruction() * defines.economy.CONVOY_CONSTRUCTION_SIZE
			if neededTransports > 0 then
				local buildRequestCount = neededTransports / defines.economy.CONVOY_CONSTRUCTION_SIZE;
				buildRequestCount = math.ceil( math.max( buildRequestCount, 1) )
				
				local cost = ministerCountry:GetConvoyBuildCost():Get()
				local res = ic / cost
				if res > 0.8 then
					buildRequestCount = math.min( buildRequestCount, math.floor(res + 0.5) )
					ic = ic - buildRequestCount * cost
					local transportCommand = CConstructConvoyCommand( ministerTag, false, buildRequestCount )
					ai:Post( transportCommand )
					--Utils.LUA_DEBUGOUT("build convoys for " .. tostring(ministerTag) )
					--Utils.LUA_DEBUGOUT("build convoys: " .. tostring(buildRequestCount) )
				end
			end
		end
		
		-- if at war, we could use protection
		if minister:GetCountry():IsAtWar() then
			local neededEscorts = minister:CountTotalDesiredEscorts()
			
			if neededEscorts > 0 then
				local buildRequestCount = neededEscorts / defines.economy.CONVOY_CONSTRUCTION_SIZE;
				buildRequestCount = math.ceil( math.max( buildRequestCount, 1) )
				
				local cost = ministerCountry:GetEscortBuildCost():Get()
				local res = ic / cost
				if res > 0.8 then
					buildRequestCount = math.min( buildRequestCount, math.floor(res + 0.5) )
					ic = ic - buildRequestCount * cost
					local escortCommand = CConstructConvoyCommand( ministerTag, true, buildRequestCount )
					ai:Post( escortCommand )
					--Utils.LUA_DEBUGOUT("build escorts for " .. tostring(ministerTag) )
					--Utils.LUA_DEBUGOUT("build escorts: " .. tostring(buildRequestCount) )
				end
			end
		end
		
	end
	return ic
end
